<?php

/**
 * Created on Fri Jul 08 2022
 *
 * @package OERSI
 * @license: MIT
 *
 * @author Edmond Kacaj <Edmond.Kacaj@tib.eu>
 *
 * Copyright (c) 2022 TIB <https://www.tib.eu/en>
 */

namespace Inc\DefaultData;

final class ElasticsSearch
{

    public static $url = 'https://oersi.org/resources/api/search/';

    public static $appName = 'oer_data_internal';

    public static $credential = '';

    public static $providerName = '';  // Neues statisches Feld auf Top-Level

    public static $fields = [
        "resultList"      => [
            "componentId"     => "results",
            "dataField"       => "name",
            "pagination"      => true,
            "stream"          => false,
            "showLoader"      => false,
            "renderError"     => true,
            "showResultStats" => true,
            "paginationAt"    => "bottom",
            "sortBy"          => null,
            "pages"           => 5,
            "size"            => 12,
            "URLParams"       => true,
            "defaultQuery"    => ["track_total_hits" => true],
            "showEndPage"     => true,
            "and"             => [
                "author",
                "license",
                "search",
                "provider",
                "learningResourceType",
                "language",
                "about",
                "sourceOrganization",
            ],
        ],
        "searchComponent" => [
            "showIcon"        => true,
            "showButton"      => false,
            "showClear"      => true,
            "filterLabel"     => "translation.SEARCH_LABEL",
            "translateText"   => "translation.SEARCH_BUTTON_TEXT",
            "componentId"     => "search",
            "queryFormat"     => "and",
            "dataField"       => [
                "name",
                "creator.name",
                "description",
                "keywords",
                "about.prefLabel_full",
                "learningResourceType.prefLabel_full"
            ],
            "fuzziness"       => 0,
            "debounce"        => 100,
            "executeSearch"   => false,
            "autosuggest"     => false,
            "highlight"       => true,
            "iconPosition"    => "right",
            "textLegth"       => 20,
            "placeholder"     => "translation.SEARCH_PLACEHOLDER",
            "showFilter"      => true,
            "URLParams"       => true,
            "customHighlight" => [
                "pre_tags"            => ["<mark>"],
                "post_tags"           => ["</mark>"],
                "number_of_fragments" => 0,
            ],
            "and"             => [
                "author",
                "license",
                "provider",
                "results",
                "learningResourceType",
                "language",
                "about",
                "sourceOrganization",
            ],
        ],
        "multiList"       => [
            [
                "componentId"                => "about",
                "dataField"                  => "about.id",
                "showTitle"                  => true,
                "title"                      => "translation.ABOUT",
                "placeholder"                => "translation.ABOUT",
                "filterLabel"                => "translation.ABOUT",
                "showMissing"                => true,
                "missingLabel"               => "N/A",
                "showFilter"                 => true,
                "showSearch"                 => true,
                "size"                       => 1000,
                "className"                  => "about-card",
                "fontAwesome"                => "",
                "URLParams"                  => true,
                "reloadAggregationsOnSearch" => false,
                "aggregationSearchDebounce"  => 1500,
                "hierarchical_filter"        => ["schemaPath" => "/locales/vocabularies_parents"],
                "aggregationSearchMinLength" => 3,
                "and"                        => [
                    "author",
                    "license",
                    "search",
                    "provider",
                    "results",
                    "language",
                    "learningResourceType",
                    "sourceOrganization",
                ],
            ],
            [
                "componentId"  => "license",
                "dataField"    => "license.id",
                "title"        => "translation.LICENSE",
                "placeholder"  => "translation.LICENSE",
                "filterLabel"  => "translation.LICENSE",
                "showMissing"  => true,
                "missingLabel" => "N/A",
                "showFilter"   => true,
                "showSearch"   => false,
                "defaultQuery" => "getPrefixAggregationQueryLicense",
                "customQuery"  => "customQueryLicense",
                "className"    => "license-card",
                "fontAwesome"  => "",
                "URLParams"    => true,
                "and"          => [
                    "author",
                    "search",
                    "provider",
                    "results",
                    "learningResourceType",
                    "language",
                    "about",
                    "sourceOrganization",
                ],
            ],
            [
                "componentId"                => "learningResourceType",
                "dataField"                  => "learningResourceType.id",
                "title"                      => "translation.RESOURCE_TYPE",
                "placeholder"                => "translation.RESOURCE_TYPE",
                "filterLabel"                => "translation.RESOURCE_TYPE",
                "showMissing"                => true,
                "missingLabel"               => "N/A",
                "showFilter"                 => true,
                "showSearch"                 => true,
                "className"                  => "lrt-card",
                "fontAwesome"                => "",
                "URLParams"                  => true,
                "reloadAggregationsOnSearch" => false,
                "aggregationSearchDebounce"  => 1500,
                "aggregationSearchMinLength" => 3,
                "and"                        => [
                    "author",
                    "license",
                    "search",
                    "provider",
                    "results",
                    "language",
                    "sourceOrganization",
                    "about",
                ],
            ],
            [
                "componentId" => "author",
                "dataField" => "persons.name.keyword",
                "nestedField" => "",
                "title" => "translation.AUTHOR",
                "placeholder" => "translation.AUTHOR",
                "filterLabel" => "translation.AUTHOR",
                "showMissing" => true,
                "missingLabel" => "N/A",
                "showSearch" => true,
                "showFilter" => true,
                "size" => 10000,
                "className" => "author-card",
                "fontAwesome" => "",
                "URLParams" => true,
                "reloadOnSearch" => true,
                "debounce" => 1000,
                "minSearchLength" => 3,
                "and" => [
                    "license",
                    "search",
                    "provider",
                    "results",
                    "learningResourceType",
                    "language",
                    "about",
                    "sourceOrganization",
                ],
            ],
            [
                "componentId"                => "sourceOrganization",
                "dataField"                  => "institutions.name",
                "title"                      => "translation.ORGANISATION",
                "placeholder"                => "translation.ORGANISATION",
                "filterLabel"                => "translation.ORGANISATION",
                "showMissing"                => true,
                "missingLabel"               => "N/A",
                "showFilter"                 => true,
                "showSearch"                 => true,
                "size"                       => 100,
                "className"                  => "source-type-card",
                "fontAwesome"                => "",
                "URLParams"                  => true,
                "reloadAggregationsOnSearch" => false,
                "aggregationSearchDebounce"  => 1500,
                "aggregationSearchMinLength" => 3,
                "and"                        => [
                    "author",
                    "license",
                    "search",
                    "provider",
                    "results",
                    "language",
                    "learningResourceType",
                    "about",
                ],
            ],
            [
                "componentId"  => "language",
                "dataField"    => "inLanguage",
                "title"        => "translation.LANGUAGE",
                "placeholder"  => "translation.LANGUAGE",
                "filterLabel"  => "translation.LANGUAGE",
                "showMissing"  => true,
                "missingLabel" => "N/A",
                "showFilter"   => true,
                "showSearch"   => false,
                "className"    => "language-card",
                "fontAwesome"  => "",
                "URLParams"    => true,
                "and"          => [
                    "author",
                    "license",
                    "search",
                    "provider",
                    "results",
                    "learningResourceType",
                    "about",
                    "sourceOrganization",
                ],
            ],
            [
                "componentId"  => "provider",
                "dataField"    => "mainEntityOfPage.provider.name",
                "title"        => "translation.PROVIDER",
                "placeholder"  => "translation.PROVIDER",
                "filterLabel"  => "translation.PROVIDER",
                "showMissing"  => true,
                "missingLabel" => "N/A",
                "showFilter"   => true,
                "showSearch"   => false,
                "className"    => "provider-card",
                "fontAwesome"  => "",
                "URLParams"    => true,
                "and"          => [
                    "author",
                    "license",
                    "search",
                    "results",
                    "learningResourceType",
                    "language",
                    "about",
                    "sourceOrganization",
                ],
            ],
        ],
    ];
}
